function [p,chi]=logrank(t1,d1,t2,d2)

%
% Copyright (c) 2010,  KULeuven-ESAT-SCD


[t1,si]=sort(t1);
d1=d1(si);
[t2,si]=sort(t2);
d2=d2(si);

t=[t1;t2];
d=[d1;d2];

times=unique(t(d==1));
teller=[];
noemer=[];

for j=1:length(times)
    o(j)=sum(t==times(j));% # failures
    n(j)=sum(t>=times(j));% # at risk
    o1(j)=sum(t1==times(j));% # failures
    n1(j)=sum(t1>=times(j));% # at risk
    o2(j)=sum(t2==times(j));% # failures
    n2(j)=sum(t2>=times(j));% # at risk
    teller(j)=o1(j)-n1(j)*o(j)/n(j);
    noemer(j)=n2(j)*n1(j)*o(j)*(n(j)-o(j))/(n(j)*n(j)*(n(j)-1));
    
end

if ~isnan(noemer(j))
    chi=(sum(teller))^2/sum(noemer);
else
    chi=(sum(teller(1:end-1)))^2/sum(noemer(1:end-1));
end

    
p=1-chi2cdf(chi,1);
