function D = makediff3(ys,ds)
% ds =1: censoring
%
% D = makediff(ys,ds)


n = length(ys);
if not(ys==sort(ys)), error('sort first in makediff!'); end
S = sparse(triu(ones(n))); 
for i=1:n,
   if ds(i)==0, S(1:i-1,i+1:end)=0; end % event
   if ds(i)>0,  for j=i:n,     S(i,j)=0; end; end % censoring
end
full(S);

D = sparse(0);
k=1;
for i=1:n
   for j=(i+1):n,
     if S(i,j)==1, 
         D(k,i)=-1; D(k,j)=1; k=k+1; end
   end
end
D = full(D);
